﻿/* German initialisation for the jQuery UI date picker plugin. */
/* Written by Milian Wolff (mail@milianw.de). */
/* Adapted and modified by Roman Liebenau (liebenau@orgAnice.de) for orgAnice, 2014 */
(function($) {
	$.datepicker.regional['de'] = {
		renderer: $.ui.datepicker.defaultRenderer,
		monthNames: [
			'Januar', 'Februar', 'März', 'April', 'Mai', 'Juni',
			'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'
		],
		monthNamesShort: [
			'Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun',
			'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'
		],
		dayNames: ['Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'],
		dayNamesShort: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
		dayNamesMin: ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'],
		dateFormat: 'dd.mm.yy',
		firstDay: 1,
		prevText: '&#x3c;zurück',
		prevStatus: '',
		prevJumpText: '&#x3c;&#x3c;',
		prevJumpStatus: '',
		nextText: 'Vor&#x3e;',
		nextStatus: '',
		nextJumpText: '&#x3e;&#x3e;',
		nextJumpStatus: '',
		currentText: 'heute',
		currentStatus: '',
		todayText: 'heute',
		todayStatus: '',
		clearText: '-',
		clearStatus: '',
		closeText: 'schließen',
		closeStatus: '',
		yearStatus: '',
		monthStatus: '',
		weekText: 'Wo',
		weekStatus: '',
		dayStatus: 'DD d MM',
		defaultStatus: '',
		isRTL: false
	};
	$.datepicker.regional['de-DE'] = $.datepicker.regional['de'];
	$.datepicker.regional['de-AT'] = jQuery.extend(true, {}, $.datepicker.regional['de']);
	$.datepicker.regional['de-AT'].monthNames[0] = "Jänner";
	$.datepicker.regional['de-AT'].monthNamesShort[0] = "Jän";

	$.extend($.datepicker.defaults, $.datepicker.regional['de']);
	$.extend($.datepicker.defaults, $.datepicker.regional['de-DE']);
	$.extend($.datepicker.defaults, $.datepicker.regional['de-AT']);
})(jQuery);
