﻿
///<reference path="../typings/jquery/jquery.cookie.d.ts"/>

declare enum Orientation {
	Horizontal,
	Vertical
}

//declare enum DeviceType {
//	Desktop,
//	Tablet,
//	Smartphone
//}


interface IDateTimeFormatInfo {
	AbbreviatedDayNames: string[];
	AbbreviatedMonthNames: string[];
	AMDesignator: string;
	DateSeparator: string;
	DayNames: string[];
	FullDateTimePattern: string;
	LongDatePattern: string;
	LongTimePattern: string;
	MonthDayPattern: string;
	MonthNames: string[];
	PMDesignator: string;
	ShortDatePattern: string;
	ShortTimePattern: string;
	SortableDateTimePattern: string;
	TimeSeparator: string;
	UniversalSortableDateTimePattern: string;
	YearMonthPattern: string;
}

interface INumberFormatInfo {
	CurrencyDecimalDigits: number;
	CurrencyDecimalSeparator: string;
	CurrencyGroupSeparator: string;
	CurrencyGroupSizes: number[];
	CurrencyNegativePattern: string;
	CurrencyPositivePattern: string;
	CurrencySymbol: string;
	NegativeSign: string;
	NumberDecimalDigits: number;
	NumberDecimalSeparator: string;
	NumberGroupSeparator: string;
	NumberGroupSizes: number[];
	NumberNegativePattern: string;
	PercentDecimalDigits: number;
	PercentDecimalSeparator: string;
	PercentGroupSeparator: string;
	PercentGroupSizes: number[];
	PercentNegativePattern: string;
	PercentPositivePattern: string;
	PercentSymbol: string;
	PerMilleSymbol: string;
	PositiveSign: string;
}

interface ICultureInfo {
	DateTimeFormat: IDateTimeFormatInfo;
	DisplayName: string;
	Name: string;
	NativeName: string;
	NumberFormat: INumberFormatInfo;
	TwoLetterISOLanguageName: string;	// required for jQuery UI
}

interface IorgAnice {
	// --- Events ---------------------------------------------------------
	on: (eventType, handler) => void;
	trigger: (eventType, data) => void;

	// --- Properties -----------------------------------------------------
	deviceType: orgAniceModule.DeviceType;
    dialogManager: DialogCommandManager;
	popupManager: PopupManager;
	ribbonManager: RibbonManager;

	CurrentCulture: ICultureInfo;
	IsTouch: boolean;
	MomentShortDatePattern(): string;
	SearchControl: ISearchControl;

	coreConst: {};

	// --- Methods --------------------------------------------------------
	CombinePath: (path: string, part: string) => string;
	ConvertUnits: (valueToConvert: string, element?: HTMLElement) => number;
	CreateGuid: () => string;
	DiffDateFromJsonDates: (start: string, end: string) => Date;
	GetEmSize: (element?: HTMLElement) => number;
	GetFontSize: (element?: HTMLElement) => number;
	IsEmptyGuid(value: any): boolean;
	IsEmptyRequestGuid(value: any): boolean;
	IsDesktop(): boolean;
	IsSmartphone(): boolean;
	IsTablet(): boolean;
	IsValidGuid(value: any): boolean;

	JsonToShortDate: (value: string) => Date;
	JsonToShortTime: (value: string) => Date;
	JsonToDateTime: (value: string) => Date;

	MakeStorageKey: (name: string) => string;

	ShowStatusMessage: (value: string, duration: number) => void;

	reportError(text: string);
	//selectImageFromList: (selector: any, selectors: any[], images: string[]) => string;

	events: Event;
}

interface IorgAniceEvent<T> {
	add(handler: { (args?: T): void });
	remove(handler: { (args?: T): void });
	trigger(args?: T);
	FireOnAdd(value: boolean): void;
}

//var orgAnice: IorgAnice;
