﻿
///<reference path="../typings/jquery/jquery.d.ts"/>
///<reference path="../typings/knockout-3.2.0.d.ts"/>

interface IRelationsResult {
    Name: string;
    Oid: string;
    Value: string;
}

interface IRelationsResultModel {
	Name: string;
	Oid: string;
	Value: string;
}

interface IIndexChangedEventArgs {
	Index: string;
	OldIndex: string;
	Key: string;
	Controller: string;
}

interface ISelectionChangedEventArgs {
	NewValue: string;
	Origin: string;
}

interface IListActivatedEventArgs {
	/// <summary><c>true</c> if activated; <c>false</c> if deactivated.</summary>
	Activated: boolean;
	/// <summary>The current value.</summary>
	Value: string;
}

interface IRelationsChangedEventArgs {
	/// <summary>The name of the controller who changed the relations.</summary>
	Controller: string;
	/// <summary>The new relations.</summary>
	Relations: IRelationsResultModel[];
}

interface IListQueryResult {
	/// <summary>The number of pages in a multi-page result.</summary>
	CountRecords: number;

	/// <summary>The current page in a multi-page result.</summary>
	CurrentRecord: number;

	/// <summary>The error message from the server.</summary>
	Error: string;

	/// <summary>The index that returned the found entry.</summary>
	Index: string;

	/// <summary>The oid of the found entry; if <see cref="success"/> is <c>false</c>, this property is invalid.</summary>
	Oid: string;

	/// <summary><c>true</c> if the operation was a success, <c>false</c> if it failed.</summary>
	Success: boolean;

	/// <summary>Gets the table on which the query was performed.</summary>
	/// <value>The table.</value>
	Table: string;

	/// <summary>Gets the value with which the query was performed.</summary>
	/// <value>The value.</value>
	Value: string;

	/// <summary>Gets the current list result. </summary>
	/// <value>An array of plain objects, each representing an entry of the result set.</value>
	List: {}[];
}

interface IChangeIndexRequest {
	index: string;
	key: string;
	count: number;
	limit: number;
	includeRelations: boolean;
}


/// <summary>Interface for index descriptor; corresponds to <b>IOrgDataIndexDescriptor</b> in <c>orgAnice.OrgDataFacade.Public</c>. </summary>
interface IIndexDescriptor {
	DisplayName: string;
	Expression: string;
	Name: string;
	Title: string;
}

/// <summary>Interface for AJAX query result;
/// 		 represents its c# pendent: <c>orgAnice.Web.Models.AjaxQueryResult</c>.</summary>
interface IAjaxQueryResult {
	Data: any;
	Dictionary: {};
	Error: string;
	Success: boolean;
	Relations: any;
}