// ReSharper disable InconsistentNaming
///<reference path="../typings/jquery/jquery.d.ts"/>
///<reference path="../typings/jquery/jquery.cookie.d.ts"/>
///<reference path="../typings/moment.d.ts"/>
///<reference path="orgAnice.d.ts"/>
var orgAniceModule;
(function (orgAniceModule) {
    (function (DeviceType) {
        DeviceType[DeviceType["Desktop"] = 0] = "Desktop";
        DeviceType[DeviceType["Tablet"] = 1] = "Tablet";
        DeviceType[DeviceType["Smartphone"] = 2] = "Smartphone";
    })(orgAniceModule.DeviceType || (orgAniceModule.DeviceType = {}));
    var DeviceType = orgAniceModule.DeviceType;
    (function (Orientation) {
        Orientation[Orientation["Horizontal"] = 0] = "Horizontal";
        Orientation[Orientation["Vertical"] = 1] = "Vertical";
    })(orgAniceModule.Orientation || (orgAniceModule.Orientation = {}));
    var Orientation = orgAniceModule.Orientation;
    orgAniceModule.OrgAniceWebTags = {
        orgAniceDomain: "orgAniceDomain",
        orgAniceProvider: "orgAniceProvider",
        orgAniceUser: "orgAniceUser",
        orgAniceAgentCaps: "orgAniceAgentCaps",
        orgAniceContinuation: "orgAniceContinuation",
        orgAniceQuery: "orgAniceQuery",
        orgAniceSession: "orgAniceSession"
    };
    var orgAnice = (function () {
        function orgAnice() {
            this.isSmartphone = false;
            this.isTablet = false;
            this.isTouch = false;
            // fallback values taken from 'de-DE'
            this.cultureInfo = {
                DateTimeFormat: {
                    AbbreviatedDayNames: ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"],
                    AbbreviatedMonthNames: [],
                    AMDesignator: "",
                    DateSeparator: ".",
                    DayNames: [],
                    FullDateTimePattern: "dddd, d. MMMM.yyyy HH:mm:ss",
                    LongDatePattern: "dddd, d. MMMM yyyy",
                    LongTimePattern: "HH:mm:ss",
                    MonthDayPattern: "d. MMMM",
                    MonthNames: [],
                    PMDesignator: "",
                    ShortDatePattern: "dd.MM.yyyy",
                    ShortTimePattern: "HH:mm",
                    SortableDateTimePattern: "yyyy-MM-ddTHH:mm:ss",
                    TimeSeparator: ":",
                    UniversalSortableDateTimePattern: "yyyy-MM-dd HH:mm:ssZ",
                    YearMonthPattern: "MMMM yyyy",
                },
                DisplayName: "Deutsch",
                Name: "de-DE",
                NativeName: "Deutsch",
                NumberFormat: undefined,
                TwoLetterISOLanguageName: "de"
            };
            this.coreConst = {};
            this.deviceType = DeviceType.Desktop;
        }
        // --- Events ---------------------------------------------------------
        orgAnice.prototype.on = function (eventType, handler) { $(document).on(eventType, handler); };
        orgAnice.prototype.trigger = function (eventType, data) { $(document).trigger(eventType, data); };
        Object.defineProperty(orgAnice.prototype, "CurrentSessionId", {
            /// <summary>Current session identifier. </summary>
            /// <returns>A string holding a GUID. </returns>
            /// <remarks>Usually, the server stores a unique id to a cookie when a user is logged on and a session is created for her/him.
            /// 		 We need this unique id in order to distinguish 2 or more sessions the same user might have opened to
            /// 		 the web service. </remarks>
            get: function () {
                var guid = $.cookie(orgAniceModule.OrgAniceWebTags.orgAniceSession);
                // in the (most unlikely) case there was no id written by the server
                if (guid == undefined || guid === "") {
                    guid = window.orgAnice.CreateGuid();
                    $.cookie(orgAniceModule.OrgAniceWebTags.orgAniceSession, guid, { path: "/" });
                }
                // ReSharper disable once QualifiedExpressionMaybeNull
                return guid.substr(0, 8);
            },
            enumerable: true,
            configurable: true
        });
        orgAnice.prototype.MomentShortDatePattern = function () {
            return "DD.MM.YY"; // this.cultureInfo.DateTimeFormat.ShortDatePattern.replace(/yyyy/, "yy");
        };
        Object.defineProperty(orgAnice.prototype, "dialogManager", {
            // --- Properties -----------------------------------------------------
            //public get DeviceType(): DeviceType { return this.deviceType; }
            //public set DeviceType(value: DeviceType) {
            //	this.deviceType = value;
            //}
            get: function () { return this._dialogManager; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(orgAnice.prototype, "popupManager", {
            get: function () { return this._popupManager; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(orgAnice.prototype, "ribbonManager", {
            get: function () { return this._ribbonManager; },
            set: function (value) { this._ribbonManager = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(orgAnice.prototype, "CurrentCulture", {
            get: function () { return this.cultureInfo; },
            set: function (value) { this.cultureInfo = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(orgAnice.prototype, "IsTouch", {
            get: function () { return this.isTouch; },
            set: function (value) { this.isTouch = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(orgAnice.prototype, "SearchControl", {
            get: function () { return this.searchControl; },
            set: function (value) {
                this.searchControl = value;
            },
            enumerable: true,
            configurable: true
        });
        // --- Methods --------------------------------------------------------
        orgAnice.prototype.ConvertUnits = function (valueToConvert, element) {
            return window.orgAnice.ConvertUnits(valueToConvert, element);
        };
        orgAnice.prototype.CombinePath = function (path, part) {
            if (path == undefined) {
                return (part == undefined) ? "" : part;
            }
            if (part == undefined)
                return path;
            if (path[path.length - 1] != "/")
                path += "/";
            if (part[0] == "/")
                part = part.substr(1);
            return path + part;
        };
        orgAnice.prototype.CreateGuid = function () {
            var d = new Date().getTime();
            var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = (d + Math.random() * 16) % 16 | 0;
                d = Math.floor(d / 16);
                return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
            });
            return uuid;
        };
        orgAnice.prototype.DiffDateFromJsonDates = function (start, end) {
            var fallback = new Date(0);
            if (start == undefined || end == undefined)
                return fallback;
            var results = /Date\(([^)]+)\)/.exec(start);
            if (results == null)
                return fallback;
            var startTicks = parseFloat(results[1]);
            if (isNaN(startTicks))
                return fallback;
            results = /Date\(([^)]+)\)/.exec(end);
            if (results == null)
                return fallback;
            var endTicks = parseFloat(results[1]);
            if (isNaN(endTicks))
                return fallback;
            var diff = endTicks - startTicks;
            var diffDate = new Date(diff);
            return diffDate;
        };
        orgAnice.prototype.IsEmptyGuid = function (value) {
            if (value == undefined || typeof value != "string" || value === "")
                return true;
            value = value.replace(/^[\{\}]/g, "");
            return value != orgAnice.EmptyGuid;
        };
        orgAnice.prototype.IsEmptyRequestGuid = function (value) {
            if (value == undefined || typeof value != "string" || value === "")
                return false;
            value = value.replace(/^[\{\}]/g, "");
            return value != orgAnice.EmptyRequestGuid;
        };
        orgAnice.prototype.IsDesktop = function () { return this.deviceType == orgAniceModule.DeviceType.Desktop; };
        orgAnice.prototype.IsSmartphone = function () { return this.deviceType == orgAniceModule.DeviceType.Smartphone; };
        orgAnice.prototype.IsTablet = function () { return this.deviceType == orgAniceModule.DeviceType.Tablet; };
        orgAnice.prototype.IsValidGuid = function (value) {
            if (value == undefined || typeof value != "string" || value === "")
                return false;
            return /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/.test(value);
        };
        orgAnice.prototype.MakeStorageKey = function (name) {
            return ("__" + this.CurrentSessionId + "_" + name).toLowerCase();
        };
        orgAnice.prototype.ShowStatusMessage = function (value, duration) {
        };
        orgAnice.prototype.reportError = function (text) {
        };
        orgAnice.EmptyGuid = "00000000-0000-0000-0000-000000000000";
        orgAnice.EmptyRequestGuid = "00000000-0000-0000-0000-000000000001";
        orgAnice.minDate = moment("1899-12-30T00:00:00"); // orgAnice CRM does not use UTC
        return orgAnice;
    }());
    orgAniceModule.orgAnice = orgAnice;
    var orgAnicePath = (function () {
        function orgAnicePath() {
        }
        orgAnicePath.prototype.CombinePath = function (path, part) {
            if (path == undefined) {
                return (part == undefined) ? "" : part;
            }
            if (part == undefined)
                return path;
            if (path[path.length - 1] != "/")
                path += "/";
            if (part[0] == "/")
                part = part.substr(1);
            return path + part;
        };
        return orgAnicePath;
    }());
    orgAniceModule.orgAnicePath = orgAnicePath;
    var orgAniceRoot = (function () {
        function orgAniceRoot() {
        }
        return orgAniceRoot;
    }());
    var orgAniceEvent = (function () {
        function orgAniceEvent() {
            this.handlers = [];
            this.isFireOnAdd = false;
        }
        orgAniceEvent.prototype.add = function (handler) {
            this.handlers.push(handler);
            if (this.isFireOnAdd) {
                var context = arguments.length == 2 ? arguments[0] : this;
                var arg = [];
                arg.push(arguments[arguments.length == 2 ? 1 : 0]);
                handler.call(context, arg);
            }
        };
        orgAniceEvent.prototype.IsFireOnAdd = function () { return this.isFireOnAdd; };
        orgAniceEvent.prototype.FireOnAdd = function (value) { this.isFireOnAdd = value; };
        orgAniceEvent.prototype.remove = function (handler) {
            if (typeof handler === "function") {
                for (var i = 0, l = this.handlers.length; i < l; i++) {
                    if (this.handlers[i] === handler) {
                        this.handlers.splice(i, 1);
                        break;
                    }
                }
            }
        };
        orgAniceEvent.prototype.trigger = function (arg) {
            var context = arguments.length == 2 ? arguments[0] : this;
            var handlers = this.handlers; //.splice(0);
            var args = [];
            if (arguments.length == 2)
                args.push(arguments[1]);
            else
                args.push(arg);
            for (var i = 0, l = handlers.length; i < l; i++) {
                handlers[i].call(context, args);
            }
        };
        return orgAniceEvent;
    }());
    orgAniceModule.orgAniceEvent = orgAniceEvent;
    orgAniceModule.IsEmptyGuid = function (value) {
        if (value == undefined || typeof value != "string" || value === "")
            return true;
        value = value.replace(/^[\{\}]/g, "");
        return value === "00000000-0000-0000-0000-000000000000";
    };
    orgAniceModule.IsEmptyRequestGuid = function (value) {
        if (value == undefined || typeof value != "string" || value === "")
            return false;
        value = value.replace(/^[\{\}]/g, "");
        return value === "00000000-0000-0000-0000-000000000001";
    };
    orgAniceModule.IsValidGuid = function (value) {
        if (value == undefined || typeof value != "string" || value === "")
            return false;
        return /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/.test(value);
    };
})(orgAniceModule || (orgAniceModule = {}));
// ReSharper disable once JsFunctionCanBeConvertedToLambda
(function (window) {
    var _this = this;
    var orgAniceRoot = {
        // path used by the theming system
        imageBasePath: "/content/themes/orgAnice/images/",
        // combines 2 path segments into 1
        combinePath: function (path, part) {
            if (path == undefined) {
                return (part == undefined) ? "" : part;
            }
            if (part == undefined) {
                return "";
            }
            if (path[path.length - 1] != "/")
                path = path.concat("/");
            if (part[0] == "/")
                part = part.substr(1);
            return path + part;
        },
        coreConst: {
            minDate: moment("1899-12-30") // minDate as defined in orgAnice core
        }
    };
    window.orgAnice = orgAniceRoot;
    $.extend(orgAniceRoot, {
        on: function (eventType, handler) { $(document).on(eventType, handler); },
        trigger: function (eventType, data) { $(document).trigger(eventType, data); },
        deviceType: orgAniceModule.DeviceType.Desktop,
        dialogManager: new DialogCommandManager(function () { return confirm("Möchten Sie den geänderten Datensatz speichern?"); }),
        reportError: function (text) {
            var message = "Es ist ein Fehler aufgetreten!\n\n";
            if (text != undefined)
                message += text;
            message += "\n\n";
            message += "Die Anwendung wird fortgesetzt. Aus Sicherheitsgründen, " +
                "und um die Integrität Ihrer Daten zu wahren, sollten Sie die Anwendung jedoch neu starten " +
                "indem Sie sich ab- und neu anmelden!";
            alert(message);
        },
        ConvertUnits: function (valueToConvert, element) {
            if (valueToConvert == undefined) {
                return 0;
            }
            var units = valueToConvert.replace(/[0-9]*/, '');
            var value = parseFloat(valueToConvert);
            switch (units) {
                case "px":
                    return value;
                case "em":
                    var emSize = parseFloat(fontSize) || 16; // fallback
                    try {
                        if (element == undefined)
                            element = document.documentElement;
                        var cfs = getComputedStyle(element, 'fontSize');
                        var fontSize = cfs.height;
                        emSize = parseFloat(fontSize) || 16;
                    }
                    catch (e) { }
                    return value * emSize;
                default:
                    return value;
            }
        },
        CreateGuid: function () {
            var d = new Date().getTime();
            var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = (d + Math.random() * 16) % 16 | 0;
                d = Math.floor(d / 16);
                return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
            });
            return uuid;
        },
        CurrentSessionId: function (string) {
            var guid = $.cookie(orgAniceModule.OrgAniceWebTags.orgAniceSession);
            // in the (most unlikely) case there was no id written by the server
            if (guid == undefined || guid === "") {
                guid = window.orgAnice.CreateGuid();
                $.cookie(orgAniceModule.OrgAniceWebTags.orgAniceSession, guid, { path: "/" });
            }
            // ReSharper disable once QualifiedExpressionMaybeNull
            return guid.substr(0, 8);
        },
        GetEmSize: function (element) {
            if (element == undefined) {
                element = document.documentElement;
            }
            var cfs = getComputedStyle(element, 'fontSize');
            var fontSize = cfs.height;
            return parseFloat(fontSize) || 16;
        },
        GetFontSize: function (element) {
            if (element == undefined) {
                element = document.documentElement;
            }
            var cfs = getComputedStyle(element, 'fontSize');
            var fontSize = window.orgAnice.ConvertUnits(cfs.fontSize);
            return parseFloat(fontSize) || 16;
        },
        IsDesktop: function () { return window.orgAnice.deviceType == orgAniceModule.DeviceType.Desktop; },
        IsSmartphone: function () { return window.orgAnice.deviceType == orgAniceModule.DeviceType.Smartphone; },
        IsTablet: function () { return window.orgAnice.deviceType == orgAniceModule.DeviceType.Tablet; },
        MakeStorageKey: function (name) {
            return ("__" + _this.CurrentSessionId + "_" + name).toLowerCase();
        },
        SetDeviceType: function (device) {
            device = device || "desktop";
            window.orgAnice.IsTouch = false;
            switch (device.toLowerCase()) {
                case "desktop":
                    window.orgAnice.deviceType = orgAniceModule.DeviceType.Desktop;
                    break;
                case "smartphone":
                    window.orgAnice.deviceType = orgAniceModule.DeviceType.Smartphone;
                    window.orgAnice.IsTouch = true;
                    break;
                case "tablet":
                    window.orgAnice.deviceType = orgAniceModule.DeviceType.Tablet;
                    window.orgAnice.IsTouch = true;
                    break;
            }
            $.cookie("DeviceType", window.orgAnice.deviceType, { expires: 30, path: "/" });
        },
        //ribbonManager: orgAniceRoot.editRibbonManager,
        JsonToShortDate: function (value) {
            try {
                if (value == undefined)
                    return "";
                var results = /Date\(([^)]+)\)/.exec(value);
                var ticks = parseFloat(results[1]);
                if (isNaN(ticks))
                    return "";
                return (new Date(ticks)).toLocaleDateString();
            }
            catch (ex) {
                return "";
            }
        },
        JsonToShortTime: function (value) {
            try {
                if (value == undefined)
                    return "";
                var results = /Date\(([^)]+)\)/.exec(value);
                var ticks = parseFloat(results[1]);
                if (isNaN(ticks))
                    return "";
                return (new Date(ticks)).toLocaleTimeString();
            }
            catch (ex) {
                return "";
            }
        },
        JsonToDateTime: function (value) {
            try {
                if (value == undefined)
                    return "";
                var results = /Date\(([^)]+)\)/.exec(value);
                var ticks = parseFloat(results[1]);
                if (isNaN(ticks))
                    return "";
                return (new Date(ticks)).toLocaleString();
            }
            catch (ex) {
                return "";
            }
        },
        DiffDateFromJsonDates: function (start, end) {
            var fallback = new Date(0);
            if (start == undefined || end == undefined)
                return fallback;
            var results = /Date\(([^)]+)\)/.exec(start);
            if (results == null)
                return fallback;
            var startTicks = parseFloat(results[1]);
            if (isNaN(startTicks))
                return fallback;
            results = /Date\(([^)]+)\)/.exec(end);
            if (results == null)
                return fallback;
            var endTicks = parseFloat(results[1]);
            if (isNaN(endTicks))
                return fallback;
            var diff = endTicks - startTicks;
            var diffDate = new Date(diff);
            return diffDate;
        },
        //selectImageFromList: (selector: any, selectors: any[], images: string[]): string => {
        //	if (selector == undefined || selectors == undefined || images == undefined) return "";
        //	var pos = selectors.indexOf(selector);
        //	if (pos == -1 || pos >= images.length) return "";
        //	var image = images[pos];
        //	return (image[0] == "/" || image[0] == "~") ? image : orgAniceRoot.combinePath(orgAniceRoot.imageBasePath, image);
        //},
        toNumber: function (value) {
            if (value == undefined)
                return 0;
            try {
                var result = value.replace(/[^-\d\.]/g, "");
                return isNaN(result) ? 0 : result;
            }
            catch (e) {
                return 0;
            }
        },
        isEmptyGuid: function (value) {
            if (value == undefined || typeof value != "string")
                return true;
            value = value.replace(/^[\{\}]/g, "");
            return value === "00000000-0000-0000-0000-000000000000";
        },
        emptyGuid: "00000000-0000-0000-0000-000000000000",
        emptyRequestGuid: "00000000-0000-0000-0000-000000000001",
        isEmptyRequestGuid: function (value) {
            if (value == undefined || typeof value != "string" || value === "")
                return false;
            value = value.replace(/^[\{\}]/g, "");
            return value === "00000000-0000-0000-0000-000000000001";
        },
        isValidGuid: function (value) {
            if (value == undefined || typeof value != "string" || value === "")
                return false;
            return /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/.test(value);
        },
        getCookie: function (name) {
            return $.cookie(name, { path: "/" });
        },
        getUserCookie: function (name) {
            var cookie = $.cookie("orgAniceUser");
            var fullName;
            if (cookie == undefined || typeof cookie != "string") {
                fullName = "user";
            }
            else {
                fullName = cookie;
            }
            fullName += name;
            return $.cookie(fullName);
        },
        getUsernameFromCookie: function () {
            var cookie = $.cookie("orgAniceUser");
            return (cookie == undefined || typeof cookie != "string") ? "unknownUser" : cookie;
        },
        pageSize: 50,
        setCookie: function (name, value) {
            $.removeCookie(name, { path: "/" });
            $.cookie(name, value, { path: "/" });
        },
        setUserCookie: function (name, value) {
            var cookie = $.cookie("orgAniceUser");
            var fullName;
            if (cookie == undefined || typeof cookie != "object") {
                fullName = "user";
            }
            else {
                fullName = cookie.Value;
            }
            fullName += name;
            return $.cookie(fullName, value, { path: "/" });
        },
        removeCookie: function (name) {
            $.removeCookie(name, { path: "/" });
        }
    });
    (function ($) {
        $.each(['show', 'hide'], function (i, ev) {
            var el = $.fn[ev];
            $.fn[ev] = function () {
                this.trigger(ev);
                return el.apply(this, arguments);
            };
        });
    })(jQuery || $);
})(window);
// TODO: this is ugly! re-define this in a more best-practices manner (i.e. in the context of the global orgAnice module)
var addressCookieName = "AddressOid";
var contactCookieName = "ContactOid";
var processCookieName = "ProcessOid";
var activityCookieName = "ActivityOid";
var addressFullnameName = "_AddressFullname";
var contactFullnameName = "_ContactFullname";
var EmptyGuid = "00000000-0000-0000-0000-000000000000";
var EmptyRequestGuid = "00000000-0000-0000-0000-000000000001";
// ReSharper restore InconsistentNaming
//# sourceMappingURL=orgAnice.js.map