﻿
///<reference path="orgAnice.data.d.ts"/>

interface IPagingMoveEventArgs {
	TargetPage: number;
}

interface IPagingControl {
    // --- Events ---------------------------------------------------------
	Move: orgAniceModule.orgAniceEvent<IPagingMoveEventArgs>;
	PropertyChanged: orgAniceModule.orgAniceEvent<string>;

    // --- Properties -----------------------------------------------------
	CurrentPage: number;

	/// <summary>The oid of the first record in the page.</summary>
	FirstOid: string;
	/// <summary>The oid of the last record in the page.</summary>
	LastOid: string;

	PageSize: number;
	TopLevel: JQuery;
	TotalPages: number;
	TotalRecords: number;

	Width: number;

	GotoPositionCommand: (position: number, count: number) => void;	// no return value; list will update async

    // --- Methods --------------------------------------------------------
	Initialize(firstPage: number, countPages: number);

	/// <summary>Updates the display.</summary>
	/// <param name="total">  Total number of records in the data store. </param>
	/// <param name="current">The current position in the data store. </param>
	Update(total: number, current: number);
}
