///<reference path="../typings/jquery/jquery.d.ts"/>
///<reference path="../typings/knockout-3.2.0.d.ts"/>
///<reference path="orgAnice.browserExtensions.d.ts"/> />
///<reference path="orgAnice.d.ts"/> />
///<reference path="orgAnice.data.d.ts"/> />
///<reference path="orgAnice.statusBar.d.ts"/> />
///<reference path="orgAnice.pagingControl.d.ts"/> />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var PagingMoveEventArgs = (function () {
    function PagingMoveEventArgs() {
    }
    Object.defineProperty(PagingMoveEventArgs.prototype, "TargetPage", {
        // --- Properties -----------------------------------------------------
        get: function () { return this.targetPage; },
        set: function (value) {
            this.TargetPage = value;
        },
        enumerable: true,
        configurable: true
    });
    return PagingMoveEventArgs;
}());
var PagingControl = (function () {
    // --- Constructor ----------------------------------------------------
    function PagingControl(options) {
        // --- Events ---------------------------------------------------------
        this.Move = new orgAniceModule.orgAniceEvent();
        this.PropertyChanged = new orgAniceModule.orgAniceEvent();
        // --- Fields ---------------------------------------------------------
        this.currentPage = ko.observable();
        this.firstPage = ko.observable(1);
        this.gotoPositionCommand = undefined;
        this.lastPage = ko.observable();
        this.pageSize = 50; // set default to 50
        this.KoTotalPages = ko.observable();
        this.KoTotalRecords = ko.observable();
    }
    Object.defineProperty(PagingControl.prototype, "CurrentPage", {
        // --- Properties -----------------------------------------------------
        get: function () { return this.currentPage(); },
        set: function (value) {
            this.currentPage(value);
            this.onPropertyChanged("CurrentPage");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "CurrentRecord", {
        get: function () { return this.currentRecord; },
        set: function (value) {
            this.currentRecord = value;
            this.onPropertyChanged("CurrentRecord");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "FirstPage", {
        get: function () { return this.firstPage(); },
        set: function (value) {
            this.firstPage(value);
            this.onPropertyChanged("FirstPage");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "FirstOid", {
        get: function () { return this.firstOid; },
        set: function (value) {
            this.firstOid = value;
            this.onPropertyChanged("FirstOid");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "LastPage", {
        get: function () { return this.lastPage(); },
        set: function (value) {
            this.lastPage(value);
            this.onPropertyChanged("LastPage");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "LastOid", {
        get: function () { return this.lastOid; },
        set: function (value) {
            this.lastOid = value;
            this.onPropertyChanged("LastOid");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "PageSize", {
        get: function () { return this.pageSize; },
        set: function (value) {
            this.pageSize = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "TopLevel", {
        get: function () { return this.toplevel; },
        set: function (value) {
            this.toplevel = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "TotalPages", {
        get: function () { return this.KoTotalPages(); },
        set: function (value) {
            this.KoTotalPages(value);
            this.onPropertyChanged("TotalPages");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "TotalRecords", {
        get: function () { return this.KoTotalRecords(); },
        set: function (value) {
            this.KoTotalRecords(value);
            this.onPropertyChanged("TotalRecords");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "Width", {
        get: function () {
            return (this.toplevel == undefined) ? 0 : this.toplevel.width();
        },
        set: function (value) {
            if (this.toplevel != undefined)
                this.toplevel.width(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagingControl.prototype, "GotoPositionCommand", {
        get: function () { return this.gotoPositionCommand; },
        set: function (value) { this.gotoPositionCommand = value; },
        enumerable: true,
        configurable: true
    });
    // --- Methods --------------------------------------------------------
    PagingControl.prototype.Initialize = function (firstPage, countPages) {
    };
    PagingControl.prototype.Update = function (total, current) {
    };
    // --- Implementation -------------------------------------------------
    PagingControl.prototype.onPropertyChanged = function (property) {
        if (this.suspendPropertyChanged)
            return;
        this.PropertyChanged.trigger(property);
    };
    return PagingControl;
}());
var DesktopPagingControl = (function (_super) {
    __extends(DesktopPagingControl, _super);
    // --- Constructor ----------------------------------------------------
    function DesktopPagingControl(options) {
        var _this = this;
        _super.call(this, options);
        this.pagingButtons = 5; // number of paging buttons
        this.viewModel = {
            pageButtons: ko.observableArray(),
            currentButton: undefined
        };
        if (options != undefined) {
            if (options.hasOwnProperty("pagingButtons"))
                this.pagingButtons = options["pagingButtons"];
        }
        this.KoTotalPages.subscribe(function (newvalue) {
            _this.infoPaneLeft.text(newvalue + (newvalue == 1 ? " Seite" : " Seiten"));
        });
        this.KoTotalRecords.subscribe(function (newValue) {
            _this.infoPaneRight.text(newValue + (newValue == 1 ? "Satz" : " Sätze"));
        });
        this.create();
    }
    // --- Properties -----------------------------------------------------
    // --- Methods --------------------------------------------------------
    DesktopPagingControl.prototype.Initialize = function (firstPage, countPages) {
        _super.prototype.Initialize.call(this, firstPage, countPages);
        this.reindexPageButtons();
        this.markCurrentPageButton();
    };
    DesktopPagingControl.prototype.Update = function (total, current) {
        this.CurrentRecord = current;
        this.TotalRecords = total;
        this.TotalPages = Math.ceil(total / this.PageSize);
        this.CurrentPage = Math.ceil(current / this.PageSize);
        if (this.TotalPages < this.pagingButtons) {
            this.pagingButtons = this.TotalPages;
            this.FirstPage = 1;
            this.LastPage = this.TotalPages;
        }
        else {
            // calculate 1st page
            if (this.CurrentPage == 1) {
                this.FirstPage = 1;
                this.LastPage = this.pagingButtons;
            }
            else {
                var pos = Math.floor(this.pagingButtons / 2);
                while ((this.CurrentPage - pos) <= 0) {
                    pos--;
                }
                this.FirstPage = this.CurrentPage - pos;
                this.LastPage = this.FirstPage + this.pagingButtons - 1;
                while (this.LastPage > this.TotalPages) {
                    this.LastPage--;
                    this.FirstPage--;
                }
            }
        }
        this.reindexPageButtons();
        this.markCurrentPageButton();
    };
    // --- Implementation -------------------------------------------------
    DesktopPagingControl.prototype.create = function () {
        var _this = this;
        this.TopLevel = $(document.createElement("div")).addClass("paging-control");
        this.infoPaneLeft = $(document.createElement("div")).addClass("paging-info-left");
        this.TopLevel.append(this.infoPaneLeft);
        this.infoPaneRight = $(document.createElement("div")).addClass("paging-info-right");
        this.TopLevel.append(this.infoPaneRight);
        var pagingButtons = $(document.createElement("div")).addClass("paging-buttons");
        var control = this;
        pagingButtons.append($(document.createElement("div")).attr("id", "toBegin").addClass("paging-button").text("<<").click(function () {
            if (control.GotoPositionCommand == undefined)
                return;
            control.GotoPositionCommand(-2147483648, _this.PageSize);
        }));
        pagingButtons.append($(document.createElement("div")).attr("id", "previous").addClass("paging-button").text("<").click(function () {
            if (control.GotoPositionCommand == undefined)
                return;
            control.GotoPositionCommand(-1, _this.PageSize, _this.FirstOid);
        }));
        //var buttons = [];
        //var button: JQuery;
        //var index = this.FirstPage, idx;
        //for (idx = this.FirstPage; idx <= this.pagingButtons; ++idx) {
        //	button = this.createPagingButton(idx);
        //	pagingButtons.append(button);
        //	buttons.push(button);
        //	index++;
        //}
        //this.viewModel.pageButtons(buttons);
        pagingButtons.append($(document.createElement("div")).attr("id", "next").addClass("paging-button").text(">").click(function () {
            if (control.GotoPositionCommand == undefined)
                return;
            control.GotoPositionCommand(1, _this.PageSize, _this.LastOid);
        }));
        pagingButtons.append($(document.createElement("div")).attr("id", "toEnd").addClass("paging-button").text(">>").click(function () {
            if (control.GotoPositionCommand == undefined)
                return;
            control.GotoPositionCommand(2147483647, _this.PageSize);
        }));
        this.TopLevel.append(pagingButtons);
    };
    DesktopPagingControl.prototype.createPagingButton = function (index) {
        var control = this;
        var button = $(document.createElement("div"))
            .text(index)
            .attr("id", "page" + index.toString())
            .addClass("paging-button").text(index.toString())
            .click(function (eventTarget) {
            if (eventTarget == undefined || eventTarget.target == undefined)
                return;
            try {
                var id = Number($(eventTarget.target).attr("id").match(/[0-9]/));
                var target = id - control.CurrentPage;
                var oid = target < 0 ? control.FirstOid : control.LastOid;
                control.GotoPositionCommand(target, control.PageSize, oid);
            }
            catch (e) {
            }
        });
        return button;
    };
    DesktopPagingControl.prototype.markCurrentPageButton = function () {
        var id = "page" + this.CurrentPage;
        $(this.viewModel.pageButtons()).each(function (index, value) {
            var jq = $(value);
            jq.removeClass("selected");
            var buttonId = jq.attr("id");
            if (buttonId == id) {
                jq.addClass("selected");
            }
        });
        var button = $(this.viewModel.pageButtons()).find(id);
    };
    DesktopPagingControl.prototype.reindexPageButtons = function () {
        var index = this.FirstPage;
        $(this.viewModel.pageButtons()).each(function (position, button) {
            $(button)
                .attr("id", "page" + index)
                .text(index);
            index++;
        });
    };
    return DesktopPagingControl;
}(PagingControl));
var MobilePagingControl = (function (_super) {
    __extends(MobilePagingControl, _super);
    // --- Constructor ----------------------------------------------------
    function MobilePagingControl(options) {
        var _this = this;
        _super.call(this, options);
        this.viewModel = {
            pageButtons: ko.observableArray(),
        };
        this.KoTotalPages.subscribe(function (newvalue) {
            _this.infoPane.text(newvalue + (newvalue == 1 ? " Seite" : " Seiten"));
        });
        this.create();
    }
    // --- Properties -----------------------------------------------------
    // --- Methods --------------------------------------------------------
    MobilePagingControl.prototype.Initialize = function (firstPage, countPages) {
        _super.prototype.Initialize.call(this, firstPage, countPages);
    };
    MobilePagingControl.prototype.Update = function (total, current) {
        this.CurrentRecord = current;
        this.TotalRecords = total;
        this.TotalPages = Math.ceil(total / this.PageSize);
        this.CurrentPage = Math.ceil(current / this.PageSize);
    };
    // --- Implementation -------------------------------------------------
    MobilePagingControl.prototype.create = function () {
        var _this = this;
        this.TopLevel = $(document.createElement("div")).addClass("paging-control");
        this.infoPane = $(document.createElement("div")).addClass("paging-info").css("display", "none");
        this.TopLevel.append(this.infoPane);
        var control = this;
        var pagingButtons = $(document.createElement("div")).addClass("paging-buttons");
        pagingButtons.append($(document.createElement("div")).attr("id", "toBegin").addClass("paging-button").text("|<")
            .click(function (ev) {
            if (control.GotoPositionCommand == undefined)
                return;
            ev.stopImmediatePropagation();
            ev.stopPropagation();
            control.GotoPositionCommand(-2147483648, _this.PageSize); // value == int.MinValue
        }));
        pagingButtons.append($(document.createElement("div")).attr("id", "previous").addClass("paging-button").text("<")
            .click(function (ev) {
            if (control.GotoPositionCommand == undefined)
                return;
            ev.stopImmediatePropagation();
            ev.stopPropagation();
            control.GotoPositionCommand(-1, _this.PageSize, _this.FirstOid);
        }));
        //var infoButton = $(document.createElement("div")).attr("id", "info").addClass("paging-button").text(" ");
        this.infoPane = $(document.createElement("div")).attr("id", "info").addClass("paging-button");
        pagingButtons.append(this.infoPane);
        //infoButton.on("taphold", () => {
        //	control.infoPane.attr("display", "block");
        //	return false;
        //});
        //infoButton
        //	.on("taphold", "#info", () => {
        //		this.infoPane.attr("display", "block");
        //	})
        //	.on("touchstart", "#info", () => {
        //		this.infoPane.attr("display", "block");
        //	})
        //	.on("vmousedown", "#info", () => {
        //		this.infoPane.attr("display", "block");
        //	})
        //	.on("touchend", "#info", () => {
        //		this.infoPane.attr("display", "none");
        //	})
        //	.on("vmouseup", "#info", () => {
        //		this.infoPane.attr("display", "none");
        //	});
        //.click((ev) => {
        //	if ( //control.CurrentPage <= 1 ||
        //		control.GotoPositionCommand == undefined) return;
        //	ev.stopImmediatePropagation();
        //	ev.stopPropagation();
        //	//control.GotoPositionCommand(-1, this.PageSize, this.FirstOid);
        //}));
        pagingButtons.append($(document.createElement("div")).attr("id", "next").addClass("paging-button")
            .text(">")
            .click(function (ev) {
            if (control.GotoPositionCommand == undefined)
                return;
            ev.stopImmediatePropagation();
            ev.stopPropagation();
            control.GotoPositionCommand(1, _this.PageSize, _this.LastOid);
        }));
        pagingButtons.append($(document.createElement("div")).attr("id", "toEnd").addClass("paging-button").text(">|")
            .click(function (ev) {
            if (control.GotoPositionCommand == undefined)
                return;
            ev.stopImmediatePropagation();
            ev.stopPropagation();
            control.GotoPositionCommand(2147483647, _this.PageSize); // value == int.MaxValue
        }));
        this.TopLevel.append(pagingButtons);
    };
    return MobilePagingControl;
}(PagingControl));
//# sourceMappingURL=orgAnice.pagingControl.js.map