///<reference path="../typings/jquery/jquery.d.ts"/>
///<reference path="../typings/knockout-3.2.0.d.ts"/>
///<reference path="orgAnice.browserExtensions.d.ts"/> />
///<reference path="orgAnice.d.ts"/> />
///<reference path="orgAnice.data.d.ts"/> />
///<reference path="orgAnice.statusBar.d.ts"/> />
///<reference path="orgAnice.shortcutControl.d.ts"/> />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// ReSharper disable RedundantVariableTypeSpecification
var ShortcutControl = (function () {
    // --- Constructor(s) -------------------------------------------------
    function ShortcutControl(options) {
        // --- Events ---------------------------------------------------------
        this.PropertyChanged = new orgAniceModule.orgAniceEvent();
        this.QueryShortcutsFinished = new orgAniceModule.orgAniceEvent();
        this.ShortcutChangedEvent = new orgAniceModule.orgAniceEvent();
        // --- Fields ---------------------------------------------------------
        this.isBound = false;
        this.height = ko.observable();
        this.width = ko.observable();
        this.instanceClass = options.instanceClass || "DesktopShortcustControl";
        this.serviceEndpoint = options.serviceEndpoint;
        this.shortcutColumn = options.shortcutColumn;
    }
    Object.defineProperty(ShortcutControl.prototype, "AllSymbol", {
        // --- Properties -----------------------------------------------------
        get: function () { return this.shortcutAllSymbol || "**"; },
        set: function (value) {
            this.shortcutAllSymbol = value;
            this.onPropertyChanged("AllSymbol");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "CurrentShortcut", {
        get: function () { return this.currentShortcut; },
        set: function (value) {
            this.currentShortcut = value;
            this.onPropertyChanged("CurrentShortcut");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "Height", {
        get: function () { return this.height(); },
        set: function (value) {
            if (value == undefined)
                return;
            value = Math.floor(value);
            if (value === this.height())
                return;
            this.height(value);
            this.onPropertyChanged("Height");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "HeightProperty", {
        get: function () { return this.height; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "IncludeAll", {
        get: function () { return this.includeAllButton || false; },
        set: function (value) {
            this.includeAllButton = value;
            this.onPropertyChanged("IncludeAll");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "ShortcutColumn", {
        get: function () { return this.shortcutColumn; },
        set: function (value) {
            this.shortcutColumn = value;
            this.onPropertyChanged("ShortcutColumn");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "ServiceEndpoint", {
        get: function () { return this.serviceEndpoint; },
        set: function (value) {
            this.serviceEndpoint = value;
            this.onPropertyChanged("ServiceEndpoint");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "Toplevel", {
        get: function () {
            return this.toplevel;
        },
        set: function (value) {
            this.toplevel = value;
            this.onPropertyChanged("Toplevel");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "ViewModel", {
        get: function () { return undefined; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "Width", {
        get: function () { return this.width(); },
        set: function (value) {
            if (value == undefined)
                return;
            value = Math.floor(value);
            if (value === this.width())
                return;
            this.width(value);
            this.onPropertyChanged("Width");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShortcutControl.prototype, "WidthProperty", {
        get: function () { return this.width; },
        enumerable: true,
        configurable: true
    });
    // --- Methods --------------------------------------------------------
    ShortcutControl.Create = function (options) {
        switch (options.instanceClass.toLowerCase()) {
            case "mobileshortcutcontrol":
                return new MobileShortcutControl(options);
            case "desktopshortcutcontrol":
            default:
                return new DesktopShortcutControl(options);
        }
    };
    ShortcutControl.prototype.QueryShortcuts = function (keyColumn) {
        var _this = this;
        if (this.serviceEndpoint == undefined || this.serviceEndpoint === "")
            return;
        var control = this;
        $.ajax({
            url: this.serviceEndpoint + "/GetListShortcuts",
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            data: { index: this.shortcutColumn },
            //data: { index: keyColumn, shortcutColumn: this.shortcutColumn }, // if undefined, the active index will be used
            cache: false,
            type: "GET"
        })
            .done(function (result) {
            if (result.Success) {
                var results = [];
                if (control.includeAllButton)
                    results.push(control.shortcutAllSymbol);
                $.each(result.Data, function (index, val) { results.push(val); });
                control.ViewModel.shortcuts(results);
            }
            else {
                $(document).statusBar().AddMessage("Fehler beim Laden der Schnellanwahl!", StatusBarMessageSeverity.Error);
            }
            _this.QueryShortcutsFinished.trigger(control);
        })
            .fail(function (xhr) {
            window.orgAnice.dialogManager.HandleAjaxError(xhr);
        });
    };
    ShortcutControl.prototype.Show = function (show) {
        if (this.toplevel == undefined)
            return;
        if (show === false) {
            this.displayStatus = this.toplevel.attr("display");
            this.toplevel.attr("display", "none");
        }
        else {
            this.toplevel.attr("display", this.displayStatus || "block");
        }
    };
    ShortcutControl.prototype.UpdateShortcuts = function (shortcuts, currentShortcut) {
        this.ViewModel.shortcuts(shortcuts);
        this.ViewModel.currentShortcut(currentShortcut);
    };
    // --- Implementation -------------------------------------------------
    ShortcutControl.prototype.onPropertyChanged = function (propertyName) {
        this.PropertyChanged.trigger(this, propertyName);
    };
    ShortcutControl.prototype.onShortcutsChanged = function (newShortcut) {
        this.ShortcutChangedEvent.trigger(this, newShortcut);
    };
    return ShortcutControl;
}());
var DesktopShortcutControl = (function (_super) {
    __extends(DesktopShortcutControl, _super);
    // --- Constructor(s) -------------------------------------------------
    function DesktopShortcutControl(options) {
        var _this = this;
        _super.call(this, options);
        this.viewmodel = {
            currentShortcut: ko.observable(),
            shortcuts: ko.observableArray([]),
            onClick: function (data, event) {
                var id = $(event.currentTarget).attr("id");
                var item = $(event.currentTarget);
                if (item != undefined) {
                    var parent = item.parent();
                    $(parent).find("li").removeClass("selected");
                    item.addClass("selected");
                }
                _this.viewmodel.currentShortcut(id);
            }
        };
        this.create(options);
    }
    Object.defineProperty(DesktopShortcutControl.prototype, "ViewModel", {
        // --- Properties -----------------------------------------------------
        get: function () { return this.viewmodel; },
        enumerable: true,
        configurable: true
    });
    // --- Methods --------------------------------------------------------
    DesktopShortcutControl.prototype.UpdateShortcuts = function (shortcuts, currentShortcut) {
        this.viewmodel.shortcuts(shortcuts);
        this.viewmodel.currentShortcut(currentShortcut);
    };
    // --- Implementation -------------------------------------------------
    DesktopShortcutControl.prototype.create = function (options) {
        var pane = $(document.createElement("div"));
        pane.attr("id", name);
        pane.addClass("shortcut-pane");
        var ul = $(document.createElement("ul"));
        ul.attr("data-bind", "foreach: shortcuts");
        var span = $(document.createElement("span"));
        span.attr("data-bind", "text: $data");
        var li = $(document.createElement("li"));
        li.attr("data-bind", "attr: { id: $data }," +
            "click: $parent.onClick");
        li.append(span);
        ul.append(li);
        pane.append(ul);
        this.Toplevel = pane;
        var control = this;
        this.resetShortcuts = $(document.createElement("div"))
            .attr("id", "reset")
            .addClass("reset")
            .click(function () {
            control.Toplevel.find("li").removeClass("selected");
            control.viewmodel.currentShortcut('');
        });
        this.Toplevel.append(this.resetShortcuts);
        this.viewmodel.currentShortcut.subscribe(function (newValue) {
            control.CurrentShortcut = newValue;
            control.ShortcutChangedEvent.trigger(control, newValue);
        });
        ko.applyBindings(this.viewmodel, pane[0]);
        return pane;
    };
    return DesktopShortcutControl;
}(ShortcutControl));
var MobileShortcutControl = (function (_super) {
    __extends(MobileShortcutControl, _super);
    // --- Methods --------------------------------------------------------
    // --- Constructor(s) -------------------------------------------------
    function MobileShortcutControl(options) {
        var _this = this;
        _super.call(this, options);
        this.viewmodel = {
            currentShortcut: ko.observable(),
            shortcuts: ko.observableArray([]),
            onClick: function (data, event) {
                var id = $(event.currentTarget).attr("id");
                var item = $(event.currentTarget);
                if (item != undefined) {
                    var parent = item.parent();
                    $(parent).find("li").removeClass("selected");
                    item.addClass("selected");
                }
                _this.viewmodel.currentShortcut(id);
            }
        };
        this.create(options);
        var control = this;
        this.viewmodel.shortcuts.subscribe(function () {
            var length = control.viewmodel.shortcuts() == undefined ? 0 : control.viewmodel.shortcuts().length;
            _this.Toplevel.attr("count-shortcuts", length);
            _this.layout({ doHeight: true });
        });
        this.HeightProperty.subscribe(function () {
            _this.layout({ doHeight: true });
        });
        this.WidthProperty.subscribe(function () {
            _this.layout({ doWidth: true });
        });
    }
    Object.defineProperty(MobileShortcutControl.prototype, "ViewModel", {
        // --- Properties -----------------------------------------------------
        get: function () { return this.viewmodel; },
        enumerable: true,
        configurable: true
    });
    // --- Implementation -------------------------------------------------
    MobileShortcutControl.prototype.create = function (options) {
        var control = this;
        this.Toplevel = $(document.createElement("div"));
        this.Toplevel.attr("id", name);
        this.Toplevel.addClass("shortcut-pane");
        this.resetShortcuts = $(document.createElement("div"))
            .attr("id", "reset")
            .addClass("reset")
            .click(function () {
            control.Toplevel.find("li").removeClass("selected");
            control.viewmodel.currentShortcut('');
        });
        this.Toplevel.append(this.resetShortcuts);
        var ul = $(document.createElement("ul")).attr("id", "shortcuts").attr("data-bind", "foreach: shortcuts");
        var span = $(document.createElement("span")).attr("data-bind", "text: $data");
        var li = $(document.createElement("li")).attr("data-bind", "attr: { id: $data }, click: $parent.onClick");
        li.append(span);
        ul.append(li);
        this.Toplevel.append(ul);
        this.viewmodel.currentShortcut.subscribe(function (newValue) {
            control.CurrentShortcut = newValue;
            control.ShortcutChangedEvent.trigger(control, newValue);
        });
        ko.applyBindings(this.viewmodel, this.Toplevel[0]);
    };
    MobileShortcutControl.prototype.layout = function (options) {
        var doHeight = options != undefined && options.hasOwnProperty("doHeight") && options["doHeight"], doWidth = options != undefined && options.hasOwnProperty("doWidth") && options["doWidth"];
        if (doHeight) {
            var height = this.Height;
            var toplevelHeight = height;
            height -= this.resetShortcuts.height();
            var items = this.Toplevel.find("li");
            if (items != undefined && items.length > 0) {
                var fontSize = 14;
                var itemHeight = Math.floor(height / items.length);
                var size = $(items[0]).css("font-size");
                if (size != undefined) {
                    fontSize = window.orgAnice.ConvertUnits(size);
                }
                var calcSize = Math.floor(itemHeight / 4 * 3);
                calcSize = Math.min(calcSize, 14); // limit to 16px
                toplevelHeight = items.length * itemHeight + this.resetShortcuts.height() + 18;
                $.each(items, function (index, item) {
                    var $item = $(item);
                    if (fontSize !== calcSize)
                        $item.css("font-size", calcSize + "px");
                    $item.height(itemHeight);
                });
            }
            this.Toplevel.height(toplevelHeight);
        }
        if (doWidth) {
            var width = this.Width;
            this.Toplevel.width(width);
        }
    };
    return MobileShortcutControl;
}(ShortcutControl));
// ReSharper restore RedundantVariableTypeSpecification
//# sourceMappingURL=orgAnice.shortcutControl.js.map