///<reference path="orgAnice.statusBar.d.ts"/>
var StatusBarMessageSeverity;
(function (StatusBarMessageSeverity) {
    StatusBarMessageSeverity[StatusBarMessageSeverity["Normal"] = 0] = "Normal";
    StatusBarMessageSeverity[StatusBarMessageSeverity["Success"] = 1] = "Success";
    StatusBarMessageSeverity[StatusBarMessageSeverity["Warning"] = 2] = "Warning";
    StatusBarMessageSeverity[StatusBarMessageSeverity["Error"] = 3] = "Error";
})(StatusBarMessageSeverity || (StatusBarMessageSeverity = {}));
var DataOperationError = (function () {
    function DataOperationError() {
    }
    Object.defineProperty(DataOperationError.prototype, "ComError", {
        get: function () { return this.ComError; },
        set: function (value) {
            this.ComError = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataOperationError.prototype, "ExceptionTypename", {
        get: function () { return this.exceptionTypename; },
        set: function (value) {
            this.exceptionTypename = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataOperationError.prototype, "Fieldname", {
        get: function () { return this.fieldname; },
        set: function (value) {
            this.fieldname = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataOperationError.prototype, "Message", {
        get: function () { return this.message; },
        set: function (value) {
            this.message = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataOperationError.prototype, "MessageKey", {
        get: function () { return this.messageKey; },
        set: function (value) {
            this.messageKey = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataOperationError.prototype, "Tablename", {
        get: function () { return this.tablename; },
        set: function (value) {
            this.tablename = value;
        },
        enumerable: true,
        configurable: true
    });
    return DataOperationError;
}());
var StatusBarMessage = (function () {
    // --- Constructor ----------------------------------------------------
    function StatusBarMessage(options) {
        this.severity = StatusBarMessage.DefaultSeverity;
        this.duration = (options.hasOwnProperty("duration") && options["duration"]) || StatusBar.DefaultDuration;
        this.message = (options.hasOwnProperty("message") && options["message"]) || "";
        this.severity = (options.hasOwnProperty("severity") && options["severity"]) || StatusBarMessage.DefaultSeverity;
    }
    Object.defineProperty(StatusBarMessage.prototype, "Duration", {
        // --- Fields ---------------------------------------------------------
        get: function () { return this.duration; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StatusBarMessage.prototype, "Message", {
        get: function () { return this.message; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StatusBarMessage.prototype, "Severity", {
        get: function () { return this.severity; },
        enumerable: true,
        configurable: true
    });
    // --- Fields ---------------------------------------------------------
    //public static Normal: number = 0;
    //public static Success: number = 10;
    //public static Warning: number = 20;
    //public static Error: number = 30;
    StatusBarMessage.DefaultSeverity = StatusBarMessageSeverity.Normal;
    return StatusBarMessage;
}());
var StatusBar = (function () {
    // --- Constructor ----------------------------------------------------
    function StatusBar(options) {
        this.defaultOptions = {
            duration: StatusBar.DefaultDuration,
            severity: StatusBarMessageSeverity.Normal
        };
        this.messages = ko.observableArray([]);
        if (options == undefined)
            options = {};
        $.extend(options, {
            displayAsOverlay: true,
            id: "orgAniceStatusBar"
        });
        this.topLevelNode = $(document.createElement("div"));
        this.topLevelNode.attr("id", options["id"]);
        this.topLevelNode.css("display", "none");
        var text = $(document.createElement("div")).attr("id", "messages");
        var button = $(document.createElement("button"));
        var queue = this.messages;
        this.messages.subscribe(function (newValue) {
            if (newValue == undefined || (typeof newValue == "object" && newValue.length == 0))
                return; // shift?
            //this.processQueue(queue);
        });
    }
    Object.defineProperty(StatusBar.prototype, "TopLevelNode", {
        // --- Events ---------------------------------------------------------
        // --- Properties -----------------------------------------------------
        get: function () {
            return this.topLevelNode;
        },
        enumerable: true,
        configurable: true
    });
    // --- Methods --------------------------------------------------------
    StatusBar.prototype.AddMessage = function (message, severity, duration, errors) {
        var options = {};
        if (typeof message == "string") {
            if (errors != undefined && errors.length > 0) {
                message += "<br>";
                var error = errors[0];
                if (error.Fieldname != undefined) {
                    message += error.Fieldname + ": ";
                }
                if (error.Message != undefined)
                    message += error.Message;
            }
            $.extend(options, { message: message }, this.defaultOptions);
        }
        else if (typeof message == "object") {
            $.extend(options, message, this.defaultOptions);
        }
        if (severity != undefined) {
            options["severity"] = severity;
        }
        if (duration != undefined && !isNaN(duration)) {
            options["duration"] = duration;
        }
        //if (arguments.length > 2 && !isNaN(arguments[2]))
        //	options["severity"] = arguments[2];
        //if (arguments.length > 1 && !isNaN(arguments[1]))
        //	options["duration"] = arguments[1];
        var msg = new StatusBarMessage(options);
        this.messages.push(msg);
        this.show(this, msg);
    };
    StatusBar.prototype.Clear = function () {
        this.topLevelNode.text("");
    };
    StatusBar.prototype.Hide = function () {
        var transition = window.orgAnice.IsTouch ? 0 : StatusBar.DefaultTransition;
        this.topLevelNode.hide(transition);
    };
    StatusBar.prototype.Show = function () {
    };
    // --- Implementation -------------------------------------------------
    StatusBar.prototype.processQueue = function (queue) {
        if (queue.length == 0)
            return;
        var message = queue.shift();
    };
    StatusBar.prototype.show = function (caller, message) {
        //var entry = $(document.createElement("div")).addClass("status-message");
        if (message.Severity != undefined) {
            this.TopLevelNode.removeClass().addClass(StatusBarMessageSeverity[message.Severity].toString().toLocaleLowerCase());
        }
        this.topLevelNode.text(message.Message);
        this.topLevelNode.show(0);
        if (message.Duration > 0) {
            setTimeout(function () {
                var c = document.statusBar;
                if (c != undefined) {
                    c.Hide();
                    c.Clear();
                }
            }, message.Duration, caller);
        }
    };
    // --- Fields ---------------------------------------------------------
    StatusBar.DefaultDuration = 2000;
    StatusBar.DefaultTransition = 200;
    return StatusBar;
}());
// ReSharper disable JsFunctionCanBeConvertedToLambda
(function ($) {
    var _this = this;
    var control;
    $.fn.statusBar = function (arg1, arg2, arg3) {
        var instance = _this;
        var $instance = $(instance);
        control = $instance.data["orgAniceStatusBar"];
        if (control == undefined) {
            control = new StatusBar(arg1);
            $instance.data["orgAniceStatusBar"] = control;
            document.statusBar = control;
            $(document.body).append(control.TopLevelNode);
        }
        return control;
    };
})(jQuery || $);
// ReSharper restore JsFunctionCanBeConvertedToLambda
//# sourceMappingURL=orgAnice.statusBar.js.map