var TapControlCommand = (function () {
    // --- Constructor ----------------------------------------------------
    function TapControlCommand(coControl, command, type) {
        this.coControl = coControl;
        this.command = command;
        this.type = type;
    }
    Object.defineProperty(TapControlCommand.prototype, "CoControl", {
        // --- Properties -----------------------------------------------------
        get: function () { return this.coControl; },
        set: function (value) { this.coControl = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TapControlCommand.prototype, "Command", {
        get: function () { return this.command; },
        set: function (value) { this.command = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TapControlCommand.prototype, "Text", {
        get: function () { return this.text; },
        set: function (value) { this.text = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TapControlCommand.prototype, "Type", {
        get: function () { return this.type; },
        set: function (value) { this.type = value; },
        enumerable: true,
        configurable: true
    });
    // --- Methods --------------------------------------------------------
    TapControlCommand.prototype.Invoke = function (control) {
        if (control == undefined)
            return;
        var content = this.parseContent(this.type, control).replace(/[\(\) -]/g, "");
        var command = this.command + ":" + content;
        //window.open(command);
        this.coControl.attr("href", command);
        this.coControl[0].click();
    };
    // --- Implementation -------------------------------------------------
    TapControlCommand.prototype.parseContent = function (arg, control) {
        if (arg == undefined || arg === "")
            return "";
        switch (arg.trim()) {
            case "html":
                return control.html();
            case "text":
                return control.text();
            case "value":
                var dial = control.attr("data-dialer");
                return dial || control.val();
            default:
                return control.attr(arg);
        }
    };
    return TapControlCommand;
}());
var TapControl = (function () {
    // --- Properties -----------------------------------------------------
    // --- Methods --------------------------------------------------------
    // --- Constructor ----------------------------------------------------
    function TapControl(args) {
        var _this = this;
        this.commands = [];
        if (args == undefined)
            return;
        this.topLevel = args;
        var $topLevel = $(this.topLevel);
        //$topLevel.css("-ms-touch-action", "none");
        //$topLevel.click((event) => {
        //	event.stopImmediatePropagation();
        //	event.preventDefault();
        //	return false;
        //});
        //$topLevel.bind("ontouchstart", (event) => {
        //	event.stopImmediatePropagation();
        //	event.preventDefault();
        //	return false;
        //});
        //$topLevel.bind("ontouchend", (event) => {
        //	event.stopImmediatePropagation();
        //	event.preventDefault();
        //	return false;
        //});
        this.name = args.id;
        this.attributes = $(args).attr("orgAnice-touch");
        if (this.attributes != undefined && this.attributes !== "") {
            this.parse(this.attributes);
        }
        var $this = this;
        $topLevel.on("taphold", function () {
            $this.commands[0].Invoke($(_this.topLevel));
            return false;
        });
    }
    // --- Implementation -------------------------------------------------
    // tel: html, sms: html || email: html || http: html|text ; mutually exclusive!
    TapControl.prototype.parse = function (args) {
        var commands = args.split(/[,]/);
        var $this = this;
        var ctrl = $(this.topLevel).parent("div");
        $.each(commands, function (index, value) {
            var parts = value.split(/[:]/);
            var coControl = $(document.createElement("a"));
            var cmd = new TapControlCommand(coControl, parts[0].trim(), parts[1].trim());
            $this.commands.push(cmd);
            //$this.coControl.attr("display", "none");
            ctrl.append(coControl);
        });
    };
    TapControl.prototype.parseContent = function (arg, control) {
        if (arg == undefined || arg === "")
            return "";
        switch (arg.trim()) {
            case "html":
                return control.html();
            case "text":
                return control.text();
            default:
                return control.attr(arg);
        }
    };
    return TapControl;
}());
// ReSharper disable JsFunctionCanBeConvertedToLambda
(function ($) {
    $.fn.tapControl = function () {
        if (!this.length)
            return this;
        return this.each(function () {
            var $instance = $(this);
            var options = $instance[0];
            var control = $instance.data("tabControl");
            if (control == undefined) {
                control = new TapControl(options);
                $instance.data("tabControl", control);
            }
            return control;
        });
    };
})(jQuery || $);
// ReSharper restore JsFunctionCanBeConvertedToLambda
//# sourceMappingURL=orgAnice.tapControl.js.map