
--CREATE DATABASE [orgAniceFacade]
--	CONTAINMENT = NONE
--	ON  PRIMARY (
--		NAME = N'orgAniceFacade',
--		FILENAME = N'{orgAniceWebDataPath}\orgAniceFacade.mdf' ,
--		SIZE = 4160KB , MAXSIZE = UNLIMITED, FILEGROWTH = 1024KB
--	)
--	LOG ON (
--		NAME = N'orgAniceFacade_log',
--		FILENAME = N'{orgAniceWebDataPath}\orgAniceFacade_log.ldf' ,
--		SIZE = 1040KB , MAXSIZE = 2048GB , FILEGROWTH = 10%
--	)
--GO

USE [orgAniceFacade]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

IF (OBJECT_ID('FK_TableLayoutsMap_TableLayouts', 'F') IS NOT NULL)
	ALTER TABLE [TableLayoutsMap] DROP CONSTRAINT [FK_TableLayoutsMap_TableLayouts]
GO

if (OBJECT_ID('TableLayoutsMap', 'U') IS NOT NULL)
	DROP TABLE [TableLayoutsMap]
GO

if (OBJECT_ID('TableLayouts', 'U') IS NOT NULL)
	DROP TABLE [TableLayouts]
GO

--if (OBJECT_ID('IndexMap', 'U') IS NOT NULL)
--	DROP TABLE [IndexMap]
--GO

/***** maps column names to OrgDB expressions *****/
CREATE TABLE [dbo].[TableLayouts] (
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[TableName] [nvarchar](50) NOT NULL,
	[ColumnName] [nvarchar](50) NOT NULL,
	[Expression] [nvarchar](max) NULL,
	[DatabaseField] [nvarchar](50) NULL,
	[Title] [nvarchar](50) NULL,
	[TitleExpression] [nvarchar](max) NULL,
	[DecimalUnits] [int] NULL,
	[SymbolListName] [nvarchar](50) NULL,
	[Name] [nvarchar](50) NULL,
	[Alignment] [nchar](1) NULL,
	[Width] [int] NULL,
	CONSTRAINT [PK_TableLayouts] PRIMARY KEY CLUSTERED (
		[Id] ASC
	) WITH ( PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON ) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

/***** maps views to TableLayouts *****/
CREATE TABLE [dbo].[TableLayoutsMap] (
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[ViewName] [nvarchar](50) NOT NULL,
	[ColumnName] [nvarchar](50) NOT NULL,
	[TableLayoutId] [int] NOT NULL,
	[Sequence] [int] NOT NULL,
	CONSTRAINT [PK_TableLayoutsMap] PRIMARY KEY CLUSTERED (
		[Id] ASC
	) WITH ( PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON ) ON [PRIMARY]
) ON [PRIMARY]

GO

--CREATE TABLE [dbo].[IndexMap](
--	[Id] [int] IDENTITY(1,1) NOT NULL,
--	[TableName] [nvarchar](100) NOT NULL,
--	[IndexName] [nvarchar](100) NOT NULL,
--	[FieldName] [nvarchar](100) NOT NULL,
--	[AddExpressionLeft] [nvarchar](10) NULL,
--	[AddExpressionRight] [nvarchar](10) NULL,
--	CONSTRAINT [PK_IndexMap] PRIMARY KEY CLUSTERED (
--		[Id] ASC
--	) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
--) ON [PRIMARY]

--GO

ALTER TABLE [dbo].[TableLayoutsMap]
	WITH CHECK ADD
	CONSTRAINT [FK_TableLayoutsMap_TableLayouts] FOREIGN KEY([TableLayoutId])
	REFERENCES [dbo].[TableLayouts] ([Id])
GO

--CREATE UNIQUE NONCLUSTERED INDEX [IX_IndexMap_Full] ON [dbo].[IndexMap] (
--	[TableName] ASC,
--	[IndexName] ASC
--) WITH ( PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF,
--		 DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
--GO

ALTER TABLE [dbo].[TableLayoutsMap] CHECK CONSTRAINT [FK_TableLayoutsMap_TableLayouts]
GO

-- -----------------------------------------------------------------------------------------------------------------------------------------------------------------
-- seed tables -----------------------------------------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------------------------------------------------

SET IDENTITY_INSERT TableLayouts ON

INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 1, 'Adressen', 'Sperrvermerk', 'Iif(Len(LTrim(Adressen->Sperrvermerk)) > 0, "Sperre", "Leer")', NULL, 'x', 'Translation("LC.Adressen.|7ee9d153", "")', 0, 'Symbole', NULL, 'L', 255 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 2, 'Adressen', 'VerknuepftMitID', 'Iif(Len(LTrim(Adressen->VerknuepftMitID)) > 0, "Verknüpfung", "Leer")', NULL, NULL, NULL, 0, 'Symbole', NULL, 'L', 255 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 3, 'Adressen', 'Name', 'Name()', NULL, 'Bezeichnung', 'Translation("VBA:FMarkWizardOptions.Label1", "")', 0, NULL, NULL, 'L', 3345 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 4, 'Adressen', 'Land', NULL, NULL, 'Land', 'Translation("LC.Adressen.|fa109f9f", "")', 0, NULL, NULL, 'L', 480 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 5, 'Adressen', 'PLZ', NULL, NULL, 'PLZ', 'Translation("VBA:FSettings.Label48", "")', 0, NULL, NULL, 'L', 765 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 6, 'Adressen', 'Ort', NULL, NULL, 'Ort', 'Translation("FC.Adressen.lblOrt|b403bff8", "")', 0, NULL, NULL, 'L', 2235 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 7, 'Adressen', 'Telefon1', NULL, NULL, 'Telefon 1', 'Translation("LC.Adressen.|1bc8d1fe", "")', 0, NULL, NULL, 'L', 2670 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 8, 'Adressen', 'EMail', NULL, 'EMail', 'E-Mail', 'Translation("VBA:FBirthday.cmdSendMail", "")', 0, NULL, NULL, 'L', 2490 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 9, 'Adressen', 'URL', NULL, 'URL', 'URL', 'Translation("LC.Adressen.|645cb4f1", "")', 0, NULL, NULL, 'L', 435 )

INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 10, 'AnsprechPartner', 'Frauherr', NULL, 'Frauherr', NULL, NULL, 0, NULL, NULL, 'L', 525 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 11, 'AnsprechPartner', 'Name', NULL, 'Name', 'Name', 'Translation("VBA:FCommonDialog.lblName", "")', 0, NULL, NULL, 'L', 1590 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 12, 'AnsprechPartner', 'Vorname', NULL, 'Vorname', 'Vorname', 'Translation("LC.Ansprechpartner.|e1eb5b23", "")', 0, NULL, NULL, 'L', 1005 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 13, 'AnsprechPartner', 'Funktion', NULL, 'Funktion', 'Funktion', 'Translation("VBA:FUserSettings.Label18", "")', 0, NULL, NULL, 'L', 1755 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 14, 'AnsprechPartner', 'Abteilung', NULL, 'Abteilung', 'Abteilung', 'Translation("LC.Ansprechpartner.|bc1796be", "")', 0, NULL, NULL, 'L', 1680 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 15, 'AnsprechPartner', 'Telefon', 'TelefonPerson()', NULL, 'Telefon', 'Translation("LC.Ansprechpartner.|09fbe70a", "")', 0, NULL, NULL, 'L', 1860 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 16, 'AnsprechPartner', 'TelefonPrivat', NULL, 'TelefonPrivat', 'Privat', 'Translation("VBASource:OrgOffice.FRecordSheetDialog.PRIVAT", "")', 0, NULL, NULL, 'L', 1770 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 17, 'AnsprechPartner', 'TelefonIP', NULL, 'TelefonIP', 'Telefon IP', 'Translation("LC.Ansprechpartner.|68d7f3bb", "")', 0, NULL, NULL, 'L', 1590 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 18, 'AnsprechPartner', 'Telefax', 'TelefaxPerson()', NULL, 'Telefax', 'Translation("VBASource:OrgOffice.FRecordSheetDialog.TELEFAX", "")', 0, NULL, NULL, 'L', 1875 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 19, 'AnsprechPartner', 'Email', NULL, 'EMail', 'E-Mail', 'Translation("VBA:FBirthday.cmdSendMail", "")', 0, NULL, NULL, 'L', 2235 )

INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 20, 'Vorgaenge', 'Betreff', 'ZeilenumbruchEntfernen(Vorgaenge->Betreff)', NULL, 'Vorgang', 'Translation("VBA:FNewDocument.Label2", "")', 0, NULL, NULL, 'L', 3045 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 21, 'Vorgaenge', 'Abgeschlossen', NULL, 'Abgeschlossen', 'Abgeschlossen', 'Translation("LC.Verkaufschancenvorgaenge.|6f311876", "")', 0, NULL, NULL, 'C', 210 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 22, 'Vorgaenge', 'Start', NULL, 'Start', 'Start', 'Translation("VBA:OSFC_FDataMaintenance.cmdStart", "")', 0, NULL, NULL, 'L', 1095 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 23, 'Vorgaenge', 'Verantwortlich', NULL, 'Verantwortlich', 'Verantwortlich', 'Translation("VBASource:Formulare.FShowAllActivities.VERANTWORTLICH", "")', 0, NULL, NULL, 'L', 1665 )

INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 24, 'Aktivitaeten', 'Erledigt', NULL, 'Erledigt', 'Erledigt', 'Translation("FC.Aktivitaeten.Registerkarten.Standard.chkErledigt|37f7f019", "")', 0, NULL, NULL, 'C', 210 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 25, 'Aktivitaeten', 'Eingang', NULL, 'Eingang', NULL, NULL, 0, NULL, NULL, 'C', 210 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 26, 'Aktivitaeten', 'Betreff', 'ZeilenumbruchEntfernen(Aktivitaeten->Betreff)', NULL, 'Betreff', 'Translation("VBA:FAnalysisWizard.Label35", "")', 0, NULL, NULL, 'L', 2175 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 27, 'Aktivitaeten', 'Datum', NULL, 'Datum', 'Datum', 'Translation("VBA:FNewAttribute.lblDateDescription", "")', 0, NULL, NULL, 'L', 1080 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 28, 'Aktivitaeten', 'Verantwortlich', NULL, 'Verantwortlich', 'Verantwortlich', 'Translation("LC.Aktivitaeten.|35cd2234", "")', 0, NULL, NULL, 'L', 900 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 29, 'Aktivitaeten', 'Typ', NULL, 'Typ', 'Typ', 'Translation("VBA:FCommonDialog.Label2", "")', 0, NULL, NULL, 'L', 330 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 30, 'Aktivitaeten', 'Verknuepft', 'Iif(Len(LTrim(Aktivitaeten->AusgangsAktivitaetID)) > 0, "Verknüpfung", "Leer")', NULL, NULL, NULL, 0, NULL, NULL, 'C', 255 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 31, 'Aktivitaeten', 'Absender', NULL, 'Absender', 'Absender', 'Translation("VBASource:OrgOffice.CAppWord.ABSENDER", "")', 0, NULL, NULL, 'L', 2595 )
INSERT INTO TableLayouts ( Id, TableName, ColumnName, Expression, DatabaseField, Title, TitleExpression, DecimalUnits, SymbolListName, Name, Alignment, Width )
	VALUES ( 32, 'Aktivitaeten', 'Empfaenger', NULL, 'Empfaenger', 'Empfänger', 'Translation("VBASource:Formulare.FShowRecipients.DATENSATZ_GELOESCHT", "")', 0, NULL, NULL, 'L', 2595 )

SET IDENTITY_INSERT TableLayouts OFF
GO

SET IDENTITY_INSERT TableLayoutsMap ON

INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 1, 'Adressen', 'Name', 3, 0 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 2, 'Adressen', 'Land', 4, 1 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 3, 'Adressen', 'PLZ', 5, 2 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 4, 'Adressen', 'Ort', 6, 3 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 5, 'Adressen', 'Telefon1', 7, 4 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 6, 'Adressen', 'EMail', 8, 5 )

INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 7, 'Ansprechpartner', 'Frauherr', 10, 0 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 8, 'Ansprechpartner', 'Name', 11, 1 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 9, 'Ansprechpartner', 'Vorname', 12, 2 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 10, 'Ansprechpartner', 'Funktion', 13, 3 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 11, 'Ansprechpartner', 'Abteilung', 14, 4 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 12, 'Ansprechpartner', 'Telefon', 15, 5 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 13, 'Ansprechpartner', 'EMail', 19, 6 )

INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 14, 'Vorgaenge', 'Betreff', 20, 0 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 15, 'Vorgaenge', 'Abgeschlossen', 21, 1 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 16, 'Vorgaenge', 'Start', 22, 2 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 17, 'Vorgaenge', 'Verantwortlich', 23, 3 )

INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 18, 'Aktivitaeten', 'Erledigt', 24, 0 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 19, 'Aktivitaeten', 'Eingang', 25, 1 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 20, 'Aktivitaeten', 'Betreff', 26, 2 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 21, 'Aktivitaeten', 'Datum', 27, 3 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 22, 'Aktivitaeten', 'Verantwortlich', 28, 4 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 23, 'Aktivitaeten', 'Typ', 29, 5 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 24, 'Aktivitaeten', 'Absender', 30, 6 )
INSERT INTO TableLayoutsMap ( Id, ViewName, ColumnName, TableLayoutId, Sequence )
	VALUES ( 25, 'Aktivitaeten', 'Empfaenger', 31, 7 )

SET IDENTITY_INSERT TableLayoutsMap OFF
GO 
