﻿
USE [orgAniceWeb]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[DeviceCaps] (
	[UniqueId] [uniqueidentifier] NOT NULL,
	[UserAgentHash] [int] NOT NULL,
	[UserAgent] [nvarchar](max) NOT NULL,
	[DialerClass] [nvarchar](200) NULL,
	[DialerFormat] [nvarchar](200) NULL,
	[Created] [datetime] NOT NULL,
	[Expires] [datetime] NULL,
	[IsPhone] [bit] NULL,
	[IsTouch] [bit] NULL,
	[IsAudio] [bit] NULL,
	[IsCanvas] [bit] NULL,
	[IsDragAndDrop] [bit] NULL,
	[IsFlexbox] [bit] NULL,
	[IsGeoLocation] [bit] NULL,
	[IsMailer] [bit] NULL,
	[IsVideo] [bit] NULL,
	[IsFontface] [bit] NULL,
	[IsTablet] [bit] NULL,
	CONSTRAINT [PK_DeviceCaps] PRIMARY KEY CLUSTERED (
		[UniqueId] ASC
	) WITH ( PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

ALTER TABLE [dbo].[DeviceCaps] ADD CONSTRAINT [DF_DeviceCaps_Created]  DEFAULT (getdate()) FOR [Created]
GO

CREATE UNIQUE NONCLUSTERED INDEX [IX_DeviceCaps_UserAgentHash] ON [dbo].[DeviceCaps] (
	[UserAgentHash] ASC
) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE TABLE [dbo].[OrgDbInstances](
	[UniqueId] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](40) NULL,
	[OdbPath] [nvarchar](1000) NULL,
	[Oid] [uniqueidentifier] NOT NULL,
	[ServerVersion] [nvarchar](max) NULL,
	[IsDisabled] [bit] NOT NULL,
	CONSTRAINT [PK_dbo.OrgDbInstances] PRIMARY KEY CLUSTERED (
		[UniqueId] ASC
	) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

CREATE NONCLUSTERED INDEX [IX_OrgDataInstance_Name] ON [dbo].[OrgDbInstances] (
	[Name] ASC
) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO

CREATE NONCLUSTERED INDEX [IX_OrgDataInstance_Oid] ON [dbo].[OrgDbInstances] (
	[Oid] ASC
) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO

CREATE NONCLUSTERED INDEX [PIX_OrgDataInstance_UniqueId] ON [dbo].[OrgDbInstances] (
	[UniqueId] ASC
) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO

ALTER TABLE [dbo].[OrgDbInstances] ADD  CONSTRAINT [DF_OrgDbInstances_Oid]  DEFAULT (newid()) FOR [Oid]

GO
-- -----------------------------------------------------------------------------------------------------------------------------------------------------------------
-- seed tables -----------------------------------------------------------------------------------------------------------------------------------------------------
-- -----------------------------------------------------------------------------------------------------------------------------------------------------------------

